searchNodes=[{"ref":"Spellbook.html","title":"Spellbook","type":"module","doc":"Introduction Spellbook is an Elixir library providing dynamic hierarchical configurations loading for your application. It is based on the ideas implemented in the Javascript node-config module. It lets you define a set of default parameters, and extend them for different deployment environments (development, staging, production, etc.) or custom needs (client id, hostname, etc.). Configurations are stored in default or custom folders containing configuration files and can be overridden and extended by environment variables. Custom configuration static and dynamic filenames and file formats can be added as needed. Quick Start Read the configuration files from the standard &lt;CWD&gt;/config folder config = Spellbook.load_config_folder() Using Spellbook.load_config_folder/0 by default will use the following filename templates (in the listed order and if they exist) with the {SOMETHING} template variables substituted: &lt;CWD&gt;/config/default.{EXT} &lt;CWD&gt;/config/default-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{ENV}.{EXT} &lt;CWD&gt;/config/{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}-{ENV}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}-{ENV}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/local.{EXT} &lt;CWD&gt;/config/local-{INSTANCE}.{EXT} &lt;CWD&gt;/config/local-{ENV}.{EXT} &lt;CWD&gt;/config/local-{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/custom-env-variables.{EXT} Spellbook will use the default environment ({ENV} = dev) and the full hostname of the machine the code gets executed on ({FULL_HOSTNAME} = my-machine.spellbook.domain). As the other template variables are not defined, the filenames using them are ignored. The resulting filenames searched/merged will be: &lt;CWD&gt;/config/default.json &lt;CWD&gt;/config/default.yaml &lt;CWD&gt;/config/dev.json &lt;CWD&gt;/config/dev.yaml &lt;CWD&gt;/config/my-machine.spellbook.domain.json &lt;CWD&gt;/config/my-machine.spellbook.domain.yaml &lt;CWD&gt;/config/my-machine.spellbook.domain-dev.json &lt;CWD&gt;/config/my-machine.spellbook.domain-dev.yaml &lt;CWD&gt;/config/local.json &lt;CWD&gt;/config/local.yaml &lt;CWD&gt;/config/local-dev.json &lt;CWD&gt;/config/local-dev.yaml &lt;CWD&gt;/config/custom-env-variables.json &lt;CWD&gt;/config/custom-env-variables.yaml By default Spellbook supports JSON and YAML file formats. Read brand&#39;s configuration from a specific folder with custom settings for a specific client config = Spellbook.default_config() |&gt; Spellbook.add_filename_format(&quot;clients/%{brand}.%{ext}&quot;) |&gt; Spellbook.load_config( folder: &quot;./test/support/brand&quot;, config_filename: &quot;brand-conf&quot;, vars: [instance: &quot;job-processor&quot;, brand: &quot;elixir&quot;, env: &quot;prod&quot;, short_hostname: &quot;worker&quot;] ) Here we specify a specific folder were to look for the configuration files (with the folder option), a custom configuration file name (with the config_filename option). The vars configuration field is used to define the variable values used in the filename templates. The Spellbook.default_config/0 function (and the Spellbook.load_config/0 one as well) configures the Spellbook to search for the following file templates: ./test/support/brand/{CONFIG_FILENAME}.{EXT} ./test/support/brand/{CONFIG_FILENAME}-{INSTANCE}.{EXT} ./test/support/brand/{CONFIG_FILENAME}-{ENV}.{EXT} ./test/support/brand/{CONFIG_FILENAME}-{SHORT_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} ./test/support/brand/{CONFIG_FILENAME}-{FULL_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} ./test/support/brand/clients/{BRAND}.{EXT} ./test/support/brand/custom-env-variables.{EXT} In this case the searched/merged files will be: ./test/support/brand/brand-conf.json ./test/support/brand/brand-conf.yaml ./test/support/brand/brand-conf-job-processor.json ./test/support/brand/brand-conf-job-processor.yaml ./test/support/brand/brand-conf-prod.json ./test/support/brand/brand-conf-prod.yaml ./test/support/brand/brand-conf-worker-prod-job-processor.json ./test/support/brand/brand-conf-worker-prod-job-processor.yaml ./test/support/brand/brand-conf-worker1.spellbook.domain-prod-job-processor.json ./test/support/brand/brand-conf-worker1.spellbook.domain-prod-job-processor.yaml ./test/support/brand/clients/elixir.json ./test/support/brand/clients/elixir.yaml ./test/support/brand/custom-env-variables.json ./test/support/brand/custom-env-variables.yaml Get a value out of a Spellbook configuration A configuration is just a Map. iex&gt; config = Spellbook.load_config_folder() %{ &quot;some&quot; =&gt; %{ &quot;value&quot; =&gt; %{ &quot;from&quot; =&gt; %{ &quot;config&quot; =&gt; &quot;a value&quot; }}}} iex&gt; is_map(config) == true true You can access the configuration values using the standard language features iex&gt; value = config[&quot;some&quot;][&quot;value&quot;][&quot;from&quot;][&quot;config&quot;] &quot;a value&quot; or using the Spellbook.get method that supports dot notation to access elements deep down the configuration structure: iex&gt; value = Spellbook.get(config, &quot;some.value.from.config&quot;) &quot;a value&quot; Use environment variables in configuration files Some situations rely heavily on environment variables to configure secrets and settings best left out of a codebase. Spellbook lets you use map the environment variable names into your configuration structure using a custom-env-variables.{EXT} file: { &quot;database&quot;: { &quot;username&quot;: &quot;DB_USERNAME&quot;, &quot;password&quot;: &quot;DB_PASSWORD&quot; } } If the DB_USERNAME and DB_PASSWORD environment variable exist, they would override the values for database.username and database.password in the configuration. Custom environment variables have precedence and override all configuration files, including local.json."},{"ref":"Spellbook.html#add_filename_format/2","title":"Spellbook.add_filename_format/2","type":"function","doc":"Adds a filename format to the list of templates to be used to generate the list of files to be searched when the configuration is loaded. Filename formats can contain template variables specified using the following interpolation format (%{VARIABLE}): &quot;special-%{env}.%{ext}&quot; &quot;config-%{username}-%{role}.json&quot; Files are loaded in the order you specify the filename formats. config = Spellbook.default_config() |&gt; Spellbook.add_filename_format(&quot;clients/%{brand}.%{ext}&quot;) |&gt; Spellbook.add_filename_format([&quot;clients/special/%{brand}-%{version}.%{ext}&quot;, &quot;clients/external-%{brand}.%{ext}&quot;])"},{"ref":"Spellbook.html#apply_config_to_application_env/4","title":"Spellbook.apply_config_to_application_env/4","type":"function","doc":"Performs a deep merge of a configuration into an application environment."},{"ref":"Spellbook.html#deep_merge/2","title":"Spellbook.deep_merge/2","type":"function","doc":"Performs a deep merge of two maps. Examples iex&gt; Spellbook.deep_merge(%{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; &quot;1&quot;, &quot;c&quot; =&gt; [1,2,3]}}, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; &quot;X&quot;}}) %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; &quot;X&quot;, &quot;c&quot; =&gt; [1, 2, 3]}}"},{"ref":"Spellbook.html#default_config/1","title":"Spellbook.default_config/1","type":"function","doc":"Sets up the default configuration for reading a generic configuration set of files. Accepts a list"},{"ref":"Spellbook.html#default_config/2","title":"Spellbook.default_config/2","type":"function","doc":"Sets up the default configuration for reading a generic configuration set of files. The valid params are: vars: Keyword or Keyword list of variables to be used in the filenames list generation. options: map with Spellbook options The default filename formats are: &lt;FOLDER&gt;/{CONFIG_FILENAME}.{EXT} &lt;FOLDER&gt;/{CONFIG_FILENAME}-{INSTANCE}.{EXT} &lt;FOLDER&gt;/{CONFIG_FILENAME}-{ENV}.{EXT} &lt;FOLDER&gt;/{CONFIG_FILENAME}-{SHORT_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} &lt;FOLDER&gt;/{CONFIG_FILENAME}-{FULL_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} &lt;FOLDER&gt;/custom-env-variables.{EXT}"},{"ref":"Spellbook.html#default_config_folder/1","title":"Spellbook.default_config_folder/1","type":"function","doc":"Sets up the default configuration for reading application configuration from a folder."},{"ref":"Spellbook.html#default_config_folder/2","title":"Spellbook.default_config_folder/2","type":"function","doc":"Sets up the default configuration for reading application configuration from a folder. The valid params are: vars: Keyword or Keyword list of variables to be used in the filenames list generation. options: map with Spellbook options The default filename formats are: &lt;CWD&gt;/config/default.{EXT} &lt;CWD&gt;/config/default-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{ENV}.{EXT} &lt;CWD&gt;/config/{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}-{ENV}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}-{ENV}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/local.{EXT} &lt;CWD&gt;/config/local-{INSTANCE}.{EXT} &lt;CWD&gt;/config/local-{ENV}.{EXT} &lt;CWD&gt;/config/local-{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/custom-env-variables.{EXT}"},{"ref":"Spellbook.html#generate/2","title":"Spellbook.generate/2","type":"function","doc":""},{"ref":"Spellbook.html#get/2","title":"Spellbook.get/2","type":"function","doc":"Retrieves a configuration value. This function supports dot notation, so you can retrieve values from deeply nested keys, like &quot;database.config.password&quot;. Examples iex&gt; Spellbook.get(%{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; &quot;1&quot;, &quot;c&quot; =&gt; [1,2,3]}}, &quot;a.b&quot;) &quot;1&quot;"},{"ref":"Spellbook.html#load_config/2","title":"Spellbook.load_config/2","type":"function","doc":"Loads the configuration files from the provided Spellbook."},{"ref":"Spellbook.html#load_config_folder/1","title":"Spellbook.load_config_folder/1","type":"function","doc":"Creates a Spellbook with the default config folder filenames list and loads them into a configuration map"},{"ref":"Spellbook.html#load_config_folder/2","title":"Spellbook.load_config_folder/2","type":"function","doc":"Creates a Spellbook with the default config folder filenames list and loads them into a configuration map"},{"ref":"Spellbook.html#load_default_config/1","title":"Spellbook.load_default_config/1","type":"function","doc":"Creates a Spellbook with the default config filenames list and loads them into a configuration map."},{"ref":"Spellbook.html#register_extensions/2","title":"Spellbook.register_extensions/2","type":"function","doc":"Registers an config file format extension and its parser. extensions = %{ &quot;csv&quot; =&gt; Crazy.Parser.CSV } Spellbook.register_extensions(spellbook, extensions)"},{"ref":"Spellbook.html#set_options/2","title":"Spellbook.set_options/2","type":"function","doc":"Sets Spellbook options. Option names are atoms. Valid options are: :folder: folder where to find the configuration. Defaults to \#{Path.join(File.cwd!(), &quot;config&quot;)}. :config_filename: name of the configuration file, default to &quot;config&quot;. :ignore_invalid_filename_formats: defauts to true. Set it to false if you want to raise an exception if a file in the generated filenames list is not found. :config: optional configuration Map or Keyword list to be merged into the final configuration. Takes precedence on everything except the environment variables."},{"ref":"Spellbook.html#set_var/2","title":"Spellbook.set_var/2","type":"function","doc":"Sets a variable to be used during filenames list generation using a 2 elements tuple."},{"ref":"Spellbook.html#set_var/3","title":"Spellbook.set_var/3","type":"function","doc":"Sets a variable to be used during filenames list generation."},{"ref":"Spellbook.html#set_vars/2","title":"Spellbook.set_vars/2","type":"function","doc":"Sets some variable to be used during filenames list generation."},{"ref":"Spellbook.html#substitute_vars/2","title":"Spellbook.substitute_vars/2","type":"function","doc":"Performs a deep substitution of variables used as map values. Examples iex&gt; Spellbook.substitute_vars(%{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; &quot;VAR&quot;, &quot;c&quot; =&gt; &quot;NOT_A_VAR&quot;}}, %{&quot;VAR&quot; =&gt; &quot;spellbook&quot;}) %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; &quot;spellbook&quot;, &quot;c&quot; =&gt; &quot;NOT_A_VAR&quot;}}"},{"ref":"Spellbook.Parser.html","title":"Spellbook.Parser","type":"behaviour","doc":"Configuration parser behaviour."},{"ref":"Spellbook.Parser.html#c:parse/1","title":"Spellbook.Parser.parse/1","type":"callback","doc":""},{"ref":"Spellbook.Parser.JSON.html","title":"Spellbook.Parser.JSON","type":"module","doc":"JSON data parser."},{"ref":"Spellbook.Parser.JSON.html#parse/1","title":"Spellbook.Parser.JSON.parse/1","type":"function","doc":"Callback implementation for Spellbook.Parser.parse/1."},{"ref":"Spellbook.Parser.YAML.html","title":"Spellbook.Parser.YAML","type":"module","doc":"YAML data parser."},{"ref":"Spellbook.Parser.YAML.html#parse/1","title":"Spellbook.Parser.YAML.parse/1","type":"function","doc":"Callback implementation for Spellbook.Parser.parse/1."},{"ref":"readme.html","title":"Spellbook","type":"extras","doc":"Spellbook"},{"ref":"readme.html#introduction","title":"Spellbook - Introduction","type":"extras","doc":"Spellbook is an Elixir library providing dynamic hierarchical configurations loading for your application. It is based on the ideas implemented in the Javascript node-config module. It lets you define a set of default parameters, and extend them for different deployment environments (development, staging, production, etc.) or custom needs (client id, hostname, etc.). Configurations are stored in default or custom folders containing configuration files and can be overridden and extended by environment variables. Custom configuration static and dynamic filenames and file formats can be added as needed."},{"ref":"readme.html#installation","title":"Spellbook - Installation","type":"extras","doc":"Add Spellbook as a dependency to your mix.exs file. defp deps do [{:spellbook, github: &quot;alexiob/spellbook&quot;}] end"},{"ref":"readme.html#documentation","title":"Spellbook - Documentation","type":"extras","doc":"The API reference can be found here."},{"ref":"readme.html#quick-start","title":"Spellbook - Quick Start","type":"extras","doc":"Read the configuration files from the standard &lt;CWD&gt;/config folder config = Spellbook.load_config_folder() Using Spellbook.load_config_folder/0 by default will use the following filename templates (in the listed order and if they exist) with the {SOMETHING} template variables substituted: &lt;CWD&gt;/config/default.{EXT} &lt;CWD&gt;/config/default-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{ENV}.{EXT} &lt;CWD&gt;/config/{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}-{ENV}.{EXT} &lt;CWD&gt;/config/{SHORT_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}-{ENV}.{EXT} &lt;CWD&gt;/config/{FULL_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/local.{EXT} &lt;CWD&gt;/config/local-{INSTANCE}.{EXT} &lt;CWD&gt;/config/local-{ENV}.{EXT} &lt;CWD&gt;/config/local-{ENV}-{INSTANCE}.{EXT} &lt;CWD&gt;/config/custom-env-variables.{EXT} Spellbook will use the default environment ({ENV} = dev) and the full hostname of the machine the code gets executed on ({FULL_HOSTNAME} = my-machine.spellbook.domain). As the other template variables are not defined, the filenames using them are ignored. The resulting filenames searched/merged will be: &lt;CWD&gt;/config/default.json &lt;CWD&gt;/config/default.yaml &lt;CWD&gt;/config/dev.json &lt;CWD&gt;/config/dev.yaml &lt;CWD&gt;/config/my-machine.spellbook.domain.json &lt;CWD&gt;/config/my-machine.spellbook.domain.yaml &lt;CWD&gt;/config/my-machine.spellbook.domain-dev.json &lt;CWD&gt;/config/my-machine.spellbook.domain-dev.yaml &lt;CWD&gt;/config/local.json &lt;CWD&gt;/config/local.yaml &lt;CWD&gt;/config/local-dev.json &lt;CWD&gt;/config/local-dev.yaml &lt;CWD&gt;/config/custom-env-variables.json &lt;CWD&gt;/config/custom-env-variables.yaml By default Spellbook supports JSON and YAML file formats. Read brand&#39;s configuration from a specific folder with custom settings for a specific client config = Spellbook.default_config() |&gt; Spellbook.add_filename_format(&quot;clients/\#{brand}.\#{ext}&quot;) |&gt; Spellbook.load_config( folder: &quot;./test/support/brand&quot;, config_filename: &quot;brand-conf&quot;, vars: [instance: &quot;job-processor&quot;, brand: &quot;elixir&quot;, env: &quot;prod&quot;, short_hostname: &quot;worker&quot;] ) Here we specify a specific folder were to look for the configuration files (with the folder option), a custom configuration file name (with the config_filename option). The vars configuration field is used to define the variable values used in the filename templates. The Spellbook.default_config/0 function (and the Spellbook.load_config/0 one as well) configures the Spellbook to search for the following file templates: ./test/support/brand/{CONFIG\\_FILENAME}.{EXT} ./test/support/brand/{CONFIG\\_FILENAME}-{INSTANCE}.{EXT} ./test/support/brand/{CONFIG\\_FILENAME}-{ENV}.{EXT} ./test/support/brand/{CONFIG\\_FILENAME}-{SHORT_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} ./test/support/brand/{CONFIG\\_FILENAME}-{FULL_HOSTNAME}-{ENV}-{INSTANCE}.{EXT} ./test/support/brand/clients/{BRAND}.{EXT} ./test/support/brand/custom-env-variables.{EXT} In this case the searched/merged files will be: ./test/support/brand/brand-conf.json ./test/support/brand/brand-conf.yaml ./test/support/brand/brand-conf-job-processor.json ./test/support/brand/brand-conf-job-processor.yaml ./test/support/brand/brand-conf-prod.json ./test/support/brand/brand-conf-prod.yaml ./test/support/brand/brand-conf-worker-prod-job-processor.json ./test/support/brand/brand-conf-worker-prod-job-processor.yaml ./test/support/brand/brand-conf-worker1.spellbook.domain-prod-job-processor.json ./test/support/brand/brand-conf-worker1.spellbook.domain-prod-job-processor.yaml ./test/support/brand/clients/elixir.json ./test/support/brand/clients/elixir.yaml ./test/support/brand/custom-env-variables.json ./test/support/brand/custom-env-variables.yaml Get a value out of a Spellbook configuration A configuration is just a Map. iex&gt; config = Spellbook.load_config_folder() %{ &quot;some&quot; =&gt; %{ &quot;value&quot; =&gt; %{ &quot;from&quot; =&gt; %{ &quot;config&quot; =&gt; &quot;a value&quot; }}}} iex&gt; is_map(config) == true true You can access the configuration values using the standard language features iex&gt; value = config[&quot;some&quot;][&quot;value&quot;][&quot;from&quot;][&quot;config&quot;] &quot;a value&quot; or using the Spellbook.get method that supports dot notation to access elements deep down the configuration structure: iex&gt; value = Spellbook.get(config, &quot;some.value.from.config&quot;) &quot;a value&quot; Use environment variables in configuration files Some situations rely heavily on environment variables to configure secrets and settings best left out of a codebase. Spellbook lets you use map the environment variable names into your configuration structure using a custom-env-variables.{EXT} file: { &quot;database&quot;: { &quot;username&quot;: &quot;DB_USERNAME&quot;, &quot;password&quot;: &quot;DB_PASSWORD&quot; } } If the DB_USERNAME and DB_PASSWORD environment variable exist, they would override the values for database.username and database.password in the configuration. Custom environment variables have precedence and override all configuration files, including local.json."},{"ref":"readme.html#license","title":"Spellbook - License","type":"extras","doc":"Spellbook is provided under the MIT license"}]